"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Trigger =
/*#__PURE__*/
function (_Component) {
  _inherits(Trigger, _Component);

  function Trigger(props) {
    var _this;

    _classCallCheck(this, Trigger);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Trigger).call(this, props));
    _this.state = {
      styles: {}
    };
    return _this;
  }

  _createClass(Trigger, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // let childStyles = this.refs.triggerContainer.children[0].style
      var childStyles = window.getComputedStyle(_reactDom.default.findDOMNode(this.refs.triggerContainer.children[0]));
      this.setState({
        styles: {
          width: childStyles.getPropertyValue('width'),
          height: childStyles.getPropertyValue('height'),
          margin: childStyles.getPropertyValue('margin')
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var styles = this.state.styles;
      return _react.default.createElement("div", {
        onMouseOver: this.onMouseOver.bind(this),
        onMouseOut: this.onMouseOut.bind(this),
        onMouseMove: this.onMouseMove.bind(this),
        onTouchStart: this.onTouchStart.bind(this),
        onTouchEnd: this.onTouchEnd.bind(this),
        ref: "triggerContainer",
        style: styles
      }, this.props.children.props.children);
    }
  }, {
    key: "onMouseOver",
    value: function onMouseOver() {
      var setVisibility = this.props.children.props.setVisibility;
      setVisibility(true);
    }
  }, {
    key: "onMouseOut",
    value: function onMouseOut() {
      var setVisibility = this.props.children.props.setVisibility;
      setVisibility(false);
    }
  }, {
    key: "onMouseMove",
    value: function onMouseMove(e) {
      var getCursorPos = this.props.children.props.getCursorPos;
      getCursorPos(e);
    }
  }, {
    key: "onTouchStart",
    value: function onTouchStart() {
      var setVisibility = this.props.children.props.setVisibility;
      setVisibility(true);
    }
  }, {
    key: "onTouchEnd",
    value: function onTouchEnd() {
      var setVisibility = this.props.children.props.setVisibility;
      setVisibility(false);
    }
  }]);

  return Trigger;
}(_react.Component);

exports.default = Trigger;

_defineProperty(Trigger, "propTypes", {
  type: _propTypes.default.string,
  children: _propTypes.default.object,
  setVisibility: _propTypes.default.func,
  getCursorPos: _propTypes.default.func
});
//# sourceMappingURL=Trigger.js.map